# PyMenu
PyMenu is a discord bot to create grocery list

## Feature
- Add items to your list by sending a message to a channel within the `GROCERY_LIST` category.
- Support for multiple lists, one for each channel.
- Easily remove items from your list by clicking on the check mark reaction.

## Screenshots
![](https://media.discordapp.net/attachments/501841539161522176/1161285342914170970/image.png?ex=6537be41&is=65254941&hm=3ace3096fd0a5d66cb8bfc8c744dbd79dcba84fc02cbaf7a02b01ffbcc7ed58d&=)

## Planned feature
- Set prices for items.
- Specify quantities for items.
- Customize the category name.
- Add images.
- Complete the Dockerfile for easy deployment
- Implement statistics for nerd

## Requirements
- make
- g++
- [DPP](https://dpp.dev)

## Installation
- install `make`
- install `g++`
- [install dpp and its dependencies](https://dpp.dev/installing.html)
- Clone the project:
``` bash
git clone https://git.chauvet.pro/starnakin/PyMenuBOT/
cd PyMenuBOT
```
- Compile the project:
``` bash
make
```
- Launch the executable:
``` bash
./PyMenu
```

## Installation - Docker
- Clone the project:
``` bash
git clone https://git.chauvet.pro/starnakin/PyMenuBOT/
cd PyMenuBOT
```
- Build the docker image.
``` bash
docker build -t pymenu .
```
- Config the bot
Edit the `docker-compose.yml` file and set the discord bot token
- Run the docker
```bash
docker-compose up -d
```
- Run the docker - alternative without docker-compose
```bash
docker run --restart=always --name=pymenu -e BOT_TOKEN=token -d pymenu
```

## Setting up on Your Discord Server
- Add the bot to your server (using [the official instance](https://discord.com/oauth2/authorize?client_id=818558187443716137&scope=bot+applications.commands&permissions=10737428544))
- Create a category called `listes-de-course`
- Inside this category, create channels for each of your grocery lists (e.g., `Wallmart`).
- You can now start adding items to your lists by sending messages in the respective channels.
